#ifndef BUFFERED_SENDER_H
#define BUFFERED_SENDER_H

#define BUFFEREDSENDER_BUFFERSIZE 32768


#ifdef WIN32
#include <winsock2.h>
#else
#include <sys/socket.h>
#define	SOCKET int
#endif
#define BS_SOCKET_ERROR 0



class BufferedSender {
private:
	char buffer[BUFFEREDSENDER_BUFFERSIZE];
	int dataSize;
	int dataSent;
	int error;
	int sendImmediate;
	int sendFlags;
public:
	SOCKET socketFD;
	BufferedSender();
	BufferedSender(SOCKET sock);
	void BufferedSend(const char *data, int length);
	int BufferedSendCompat(SOCKET sock, const char *data, int length, int flags);
	void SendBuffered();
	int SendDataNow(const char *data, int len);
	int FinishSending();
};

#endif


